# ProcessSpec
#
# Tests for Shrewd::ProcessSpec class

module Shrewd
  require 'shrewd/entities/process'
  require 'shrewd/entities/event'
end

describe Shrewd::Process do

  describe "initialization" do
    let(:name) { 'Service Event' }
    let(:description) { 'Servicing a customer.' }
    let(:event) { Shrewd::Event.new('Event') }
    let(:conditions) { Proc.new { |variables| true } }
    let(:delay) { Proc.new { |variables| 15 } }

    context "with only name" do
      before :each do
        @process = Shrewd::Process.new(name)
      end

      it "should be valid" do
        expect(@process).to be_an_instance_of Shrewd::Process
        expect(@process.name).to eql name
        expect(@process.description).to be_empty
        expect(@process.event).to be_nil
        expect(@process.conditions).to be_nil
        expect(@process.delay).to be_nil
      end
    end

    context "with all parameters" do
      before :each do
        @process = Shrewd::Process.new(name, description,
                                       event, conditions, delay)
      end

      it "should be valid" do
        expect(@process).to be_an_instance_of Shrewd::Process
        expect(@process.name).to eql name
        expect(@process.description).to eql description
        expect(@process.event).to eql event
        expect(@process.conditions).to eql conditions
        expect(@process.delay).to eql delay
      end
    end
  end

end
